import re

COLLAPSE_BRACE_RE = re.compile(r'''
( *)".+?": { *
\1  "(key|value)": \S+ *
\1}.*'''[1:])
COLLAPSE_LIST_RE = re.compile(r'''
( *)".+?": { *
\1  \S+ \[ *
\1    \S+ *
\1  \] *
\1}.*'''[1:])

def collapse_short_json2(s):
    def collapse(m):
        lines = m.group(0).split('\n')
        return lines[0] + ''.join(l.strip() for l in lines[1:])
    s = COLLAPSE_LIST_RE.sub(collapse, s)
    s = COLLAPSE_BRACE_RE.sub(collapse, s)
    return s

if __name__ == '__main__':
    print('test')
