function init()
  local following = config.getParameter("following")
  widget.setText("follow", following and "unfollow" or "follow")

  self.entityId = config.getParameter("entityId")

  self.types = {
    head = "headarmor",
    chest = "chestarmor",
    legs = "legsarmor",
    back = "backarmor",
    primary = "activeitem",
    alt = "activeitem",
    sheathedprimary = "activeitem",
    sheathedalt = "activeitem"
  }
  self.slots = {}
  for slot, _ in pairs(self.types) do
    local equipped = config.getParameter(slot)
    widget.setItemSlotItem(slot, equipped)
    self.slots[slot] = equipped
  end
  setHealth(config.getParameter("health", "?"), config.getParameter("maxHealth", "?"))
  setFood(config.getParameter("food", "?"), config.getParameter("maxFood", "?"))


  self.followingMessage = nil
  self.statusMessage = nil

  self.statusTimer = 0
end

function swapItem(widgetName)
  local currentItem = self.slots[widgetName]
  local swapItem = player.swapSlotItem()
  if swapItem then
    sb.logWarn("itemType: " .. tostring(root.itemType(swapItem.name)))
  end
  if not swapItem or root.itemType(swapItem.name) == self.types[widgetName] then
    player.setSwapSlotItem(currentItem)
    widget.setItemSlotItem(widgetName, swapItem)
    self.slots[widgetName] = swapItem
    world.sendEntityMessage(pane.sourceEntity(), "setSlot", widgetName, swapItem)
  end
end

function follow()
  self.followingMessage = world.sendEntityMessage(pane.sourceEntity(), "toggleFollow", player.uniqueId())
end

function statusString(stat, statMax)
  return math.floor(stat) .. "/" .. math.floor(statMax)
end

function setHealth(health, maxHealth)
  widget.setText("healthtext", statusString(health, maxHealth))
end
function setFood(food, maxFood)
  widget.setText("foodtext", statusString(food, maxFood))
end

function updateStatus(dt)
  local health = world.entityHealth(self.entityId)
  if health ~= nil then
    setHealth(health[1], health[2])
  end
  -- if self.statusMessage and self.statusMessage:finished() then
  --   if self.statusMessage:succeeded() then
  --     local status = self.followingMessage:result()
  --     setHealth(status.health, status.maxHealth)
  --   end
  --   self.statusMessage = nil
  --   self.statusTimer = 0
  -- end
  -- if self.statusTimer > 2 then
  --   world.sendEntityMessage(pane.sourceEntity(), "getStatus")
  -- end
  -- self.statusTimer += dt
end

function updateFollowing()
  if self.followingMessage and self.followingMessage:finished() then
    if self.followingMessage:succeeded() then
      widget.setText("follow", self.followingMessage:result() and "unfollow" or "follow")
    else
      sb.logError("Failed to toggle follow clansman")
    end
    self.followingMessage = nil
  end
end

function update(dt)
  updateStatus(dt)
  updateFollowing()
end
