require "/scripts/vec2.lua"
require "/scripts/util.lua"

function init()
  self.existingDrawables = {}
end

function update()
  localAnimator.clearDrawables()
  self.existingDrawables = {}

  local aim = animationConfig.animationParameter("aim") or {0, 0}
  aim = {math.floor(aim[1]), math.floor(aim[2])}
  localAnimator.addDrawable({
    image = "/items/active/effects/white8x8.png:1",
    fullbright = true,
    position = aim,
    centered = false,
    color = {255, 255, 255, 64}
  }, "overlay")

  local center = animationConfig.animationParameter("center") or {0, 0}
  center = {math.floor(center[1]), math.floor(center[2])}
  sb.logInfo("drawing paint " .. tostring(center[1]) .. ", " .. tostring(center[2]))
  local searchRange = 30
  for x = -searchRange, searchRange do
    for y = -searchRange, searchRange do
      local pos = {x + center[1], y + center[2]}

      local color = world.materialColor(pos, "foreground")
      if color == 2 then
        local key = table.concat(pos, ',')
        if self.existingDrawables[key] == nil then
          sb.logInfo("drawing new paint found" .. dumpx(pos))
          localAnimator.addDrawable({
              image = "/items/active/effects/white8x8.png:1",
              --image = "/items/active/unsorted/oredetector/detectnoise.png:1",
              fullbright = true,
              position = pos,
              centered = false,
              color = {0, 0, 255, 128}
            }, "overlay")
           self.existingDrawables[key] = true
        end
      end
    end
  end
end

function dumpx(x)
  if type(x) == 'table' then
    local s = '{ '
    for k,v in pairs(x) do
      if type(k) ~= 'number' then k = '"'..k..'"' end
      s = s .. '['..k..'] = ' .. dumpx(v) .. ','
    end
    return s .. '} '
  else
    return tostring(x)
  end
end
