clansman = {

}

function extraInit()
  if storage.leaderUuid == nil then
    storage.leaderUuid = false
  end

  self.guiConfig = {
    baseConfig = "/interface/scripted/clansman/interactgui.config",
    following = not not storage.leaderUuid
  }

  message.setHandler("toggleFollow", function(_, _, uuid)
      return not not toggleFollow(uuid) 
  end)
  message.setHandler("setSlot", function(_, _, slot, item)
      -- Bug Report:
      -- npc.getItemSlot("sheathedprimary")
      -- does not return the item given to
      -- npc.setItemSlot("sheathedprimary")
      -- but instead some other value, set at initialization?
      npc.setItemSlot(slot, item)
      -- See setnpcitemslot for housekeeping below
      storage.itemSlots = storage.itemSlots or {}
      storage.itemSlots[string.lower(slot)] = item

      self.primary = npc.getItemSlot("primary")
      self.alt = npc.getItemSlot("alt")

      if slot == "sheathedprimary" then
        self.sheathedPrimary = item
      elseif slot == "sheathedalt" then
        self.sheathedAlt = item
      end
  end)
end

-- Hijack recruitable.update so we can coexist with bmain.update
function recruitable.update(dt)
  if status.resourcePercentage("health") < 0.95 then
    status.setPersistentEffects("healthbar", {"healthbar"})
  else
    status.clearPersistentEffects("healthbar")
  end

  if status.resourcePercentage("food") < 0.5 then
    status.setPersistentEffects("foodbar", {"foodbar"})
  else
    status.clearPersistentEffects("foodbar")
  end
end

function handleInteractFollow(args)
  toggleFollow(world.entityUniqueId(args.sourceId))
end

function toggleFollow(uuid)
  if uuid and uuid ~= storage.leaderUuid then
    storage.leaderUuid = uuid
  else
    storage.leaderUuid = false
  end
  return storage.leaderUuid
end

function handleInteractInventory(args)
  -- Show a menu with this clansman's slots
  self.guiConfig.following = not not storage.leaderUuid
  self.guiConfig.head = npc.getItemSlot("head")
  self.guiConfig.chest = npc.getItemSlot("chest")
  self.guiConfig.legs = npc.getItemSlot("legs")
  self.guiConfig.back = npc.getItemSlot("back")
  -- Don't use npc.getItemSlot, see bug report above
  self.guiConfig.primary = self.primary
  self.guiConfig.alt = self.alt
  self.guiConfig.sheathedprimary = self.sheathedPrimary
  self.guiConfig.sheathedalt = self.sheathedAlt
  self.guiConfig.health = status.resource("health")
  self.guiConfig.maxHealth = status.resourceMax("health")
  self.guiConfig.food = status.resource("food")
  self.guiConfig.maxFood = status.resourceMax("food")
  self.guiConfig.entityId = entity.id()
  return {"ScriptPane", self.guiConfig}
end

function handleInteract(args)
  return handleInteractInventory(args)
end
