require "/scripts/actions/movement.lua"

-- no args, just edit the code
function followIfFollowing(args, board, node, dt)
  -- recreate behaviors/npc/crew/follow
  local uuid = storage.leaderUuid
  if uuid == false or uuid == nil then
    return false
  end
  local id = world.loadUniqueEntity(uuid)
  if id == nil or id == 0 then
    return false
  end
  local leaderPosition = world.entityPosition(id)
  local pos = leaderPosition
  world.debugLine(pos, vec2.add(pos, 1), 'yellow')
  world.debugLine(vec2.add(pos, {1, 0}), vec2.add(pos, {0, 1}), 'yellow')
  local distance = world.magnitude(leaderPosition, entity.position())
  local near = config.getParameter("innerFollowRange", 5)
  local far = config.getParameter("outerFollowRange", 15)
  local catchingUp = not not storage.catchingUp
  if (catchingUp and distance > near) or (not catchingUp and distance > far) then
    storage.catchingUp = true
    local co = coroutine.create(moveToPosition)
    local coStatus, status, path = coroutine.resume(co, {
      avoidLiquid=true,
      groundPosition=true,
      maxGround=5,
      minGround=-20,
      pathOptions={},
      position=leaderPosition,
      run=true},
      board, node)
    local timer = 5.0
    while status == nil and coStatus == true and timer > 0 do
      timer = timer - dt
      coStatus, status, path = coroutine.resume(co)
      dt = coroutine.yield()
    end
    -- TODO: sayToEntity cantreach
    -- intentionally don't teleport clansman
  else
    storage.catchingUp = false
    -- Make sure we don't wander away
    storage.homePosition = entity.position()
  end
  return true
  -- return true?
end

