function dumpx(x)
  if type(x) == 'table' then
    local s = '{ '
    for k,v in pairs(x) do
      if type(k) ~= 'number' then k = '"'..k..'"' end
      s = s .. '['..k..'] = ' .. dumpx(v) .. ','
    end
    return s .. '} '
  else
    return tostring(x)
  end
end

-- ACTIONS

function paintPosition(args, board, node, dt)
  sb.logWarn('paintposition ' .. dumpx(args))
  if args.position == nil then return false end
  if args.color == nil then return false end
  local pos = args.position
  world.debugLine(pos, vec2.add(pos, 1), args.color)
  world.debugLine(vec2.add(pos, {1, 0}), vec2.add(pos, {0, 1}), args.color)
  return true
end

function logN(args, board, node, dt)
  local name = args.name or node
  sb.logInfo('starting ' .. name)
  local result = coroutine.yield()
  sb.logInfo('finished ' .. name .. ' result ' .. tostring(result))
  return result
end

function logM(args, board, node, dt)
  sb.logInfo(args.message)
  return true
end
