function init()
  self.barSize = root.imageSize("/stats/effects/healthbar/healthbar_solid_bar.png")

  self.resource = config.getParameter("resource")
  self.color = config.getParameter("color")
  updateHealthBar()
  
  self.name = config.getParameter("name")
  self.yOffset = getConcurrentBarHeight()
  animator.translateTransformationGroup("tgroup", {0, self.yOffset})

  animator.setAnimationState("mainState", "on")

  script.setUpdateDelta(10)
end

function update(dt)
  updateHealthBar()
  self.yOffset = getConcurrentBarHeight()
  animator.resetTransformationGroup("tgroup")
  animator.translateTransformationGroup("tgroup", {0, self.yOffset})
end

-- From /scripts/deployment/playermechdeployment.lua
function updateHealthBar()
  local imageBase = "/stats/effects/healthbar/healthbar_solid_bar.png"

  local cropWidth = math.floor(self.barSize[1] * status.resourcePercentage(self.resource))
  local imagePath = string.format(imageBase .. "?crop=0;0;%d;%d;?multiply=%s", cropWidth, self.barSize[2], self.color)
  animator.setPartTag('bar', 'partImage', imagePath)
end

function getConcurrentBarHeight()
  -- Yuck!!! but easiest way to get other effects config
  -- root.assetJson('/stats/effects/healthbar/' .. effect .. '.statuseffect')
  local barPriorities = {
    healthbar = 10,
    foodbar = 1
  }

  local effects = status.activeUniqueStatusEffectSummary()
  local yOffset = 0
  for index, pair in pairs(effects) do
    name = pair[1]
    sb.logInfo("status: " .. name)
    if barPriorities[name] ~= nil then
      if barPriorities[name] > barPriorities[self.name] then
        yOffset = yOffset + 0.5
      end
    end
  end
  sb.logInfo("offset: " .. tostring(yOffset))
  return yOffset
end
